# Enum rustdoc_json_types::Type

source ·

    pub enum Type {
    Show 14 variants    ResolvedPath(Path),
        DynTrait(DynTrait),
        Generic(String),
        Primitive(String),
        FunctionPointer(Box<FunctionPointer>),
        Tuple(Vec<Type>),
        Slice(Box<Type>),
        Array {
            type_: Box<Type>,
            len: String,
        },
        Pat {
            type_: Box<Type>,
            /* private fields */
        },
        ImplTrait(Vec<GenericBound>),
        Infer,
        RawPointer {
            mutable: bool,
            type_: Box<Type>,
        },
        BorrowedRef {
            lifetime: Option<String>,
            mutable: bool,
            type_: Box<Type>,
        },
        QualifiedPath {
            name: String,
            args: Box<GenericArgs>,
            self_type: Box<Type>,
            trait_: Option<Path>,
        },
    }

## Variants§

§

### ResolvedPath(Path)

Structs, enums, and unions

§

### DynTrait(DynTrait)

§

### Generic(String)

Parameterized types

§

### Primitive(String)

Built in numeric (i*, u*, f*) types, bool, and char

§

### FunctionPointer(Box<FunctionPointer>)

`extern "ABI" fn`

§

### Tuple(Vec<Type>)

`(String, u32, Box<usize>)`

§

### Slice(Box<Type>)

`[u32]`

§

### Array

[u32; 15]

#### Fields

§`type_: Box<Type>`
§`len: String`
§

### Pat

`u32 is 1..`

#### Fields

§`type_: Box<Type>`
§

### ImplTrait(Vec<GenericBound>)

`impl TraitA + TraitB + ...`

§

### Infer

`_`

§

### RawPointer

`*mut u32`, `*u8`, etc.

#### Fields

§`mutable: bool`
§`type_: Box<Type>`
§

### BorrowedRef

`&'a mut String`, `&str`, etc.

#### Fields

§`lifetime: Option<String>`
§`mutable: bool`
§`type_: Box<Type>`
§

### QualifiedPath

Associated types like `<Type as Trait>::Name` and `T::Item` where `T: Iterator` or inherent associated types like `Struct::Name`.

#### Fields

§`name: String`
§`args: Box<GenericArgs>`
§`self_type: Box<Type>`
§`trait_: Option<Path>`

`None` iff this is an inherent associated type.

## Trait Implementations§

source§

### impl Clone for Type

source§

#### fn clone(&self) -> Type

Returns a copy of the value. Read more
1.0.0 · source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
source§

### impl Debug for Type

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
source§

### impl<'de> Deserialize<'de> for Type

source§

#### fn deserialize<__D>(__deserializer: __D) -> Result<Self, __D::Error>
where __D: Deserializer<'de>,

Deserialize this value from the given Serde deserializer. Read more
source§

### impl Hash for Type

source§

#### fn hash<__H: Hasher>(&self, state: &mut __H)

Feeds this value into the given `Hasher`. Read more
1.3.0 · source§

#### fn hash_slice<H>(data: &[Self], state: &mut H)
where H: Hasher, Self: Sized,

Feeds a slice of this type into the given `Hasher`. Read more
source§

### impl PartialEq for Type

source§

#### fn eq(&self, other: &Type) -> bool

This method tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 · source§

#### fn ne(&self, other: &Rhs) -> bool

This method tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
source§

### impl Serialize for Type

source§

#### fn serialize<__S>(&self, __serializer: __S) -> Result<__S::Ok, __S::Error>
where __S: Serializer,

Serialize this value into the given Serde serializer. Read more
source§

### impl Eq for Type

source§

### impl StructuralPartialEq for Type

## Auto Trait Implementations§

§

### impl Freeze for Type

§

### impl RefUnwindSafe for Type

§

### impl Send for Type

§

### impl Sync for Type

§

### impl Unpin for Type

§

### impl UnwindSafe for Type

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> CloneToUninit for T
where T: Clone,

source§

#### default unsafe fn clone_to_uninit(&self, dst: *mut T)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dst`. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
source§

### impl<T> DeserializeOwned for T
where T: for<'de> Deserialize<'de>,

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 96 bytes

Size for each variant:

- `ResolvedPath`: 64 bytes
- `DynTrait`: 56 bytes
- `Generic`: 32 bytes
- `Primitive`: 32 bytes
- `FunctionPointer`: 16 bytes
- `Tuple`: 32 bytes
- `Slice`: 16 bytes
- `Array`: 40 bytes
- `Pat`: 40 bytes
- `ImplTrait`: 32 bytes
- `Infer`: 0 bytes
- `RawPointer`: 24 bytes
- `BorrowedRef`: 48 bytes
- `QualifiedPath`: 96 bytes